#if !defined(AFX_NSSPLITTER_H__48442C17_FC1F_11D4_B808_E15C90503603__INCLUDED_)
#define AFX_NSSPLITTER_H__48442C17_FC1F_11D4_B808_E15C90503603__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// NSSplitter.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CNSSplitter frame with splitter

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CNSSplitter : public CSplitterWnd
{
	DECLARE_DYNCREATE(CNSSplitter)
public:
	CNSSplitter();
	~CNSSplitter();

	BOOL SetBitmaps(UINT nRes,UINT nResHover);

	// returns the current status if flat
	BOOL SetAsFlat(BOOL bFlat=TRUE);
	BOOL IsFlat() { return m_bFlatSplitter; }

	int SetOptimizedSize(int cx,BOOL bFromLeftTop=TRUE);

	// returns previous splitter width
	int SetSplitterWidth(int nWidth);
	BOOL IsVerticalSplitter() { return m_nRows==1; }
	BOOL IsBarOnEdge();
	
	BOOL UseHandCursor(BOOL bHand);
	BOOL IsUsingHandCursor() { return m_bUseHandCursor; }
protected:

	virtual void OnDrawSplitter(CDC* pDC, ESplitType nType, const CRect& rectArg);
	void DrawSplitterBitmap(CDC* pDC, ESplitType nType, const CRect& rectArg);
	void UpdateSplitterBitmap(BOOL bChecked);
	BOOL SetCustomCursor(BOOL bHandCursor);
	void CreateArrowRgn(CRgn &rgn,const CRect &rect,BOOL bVerticalSplitter,BOOL bDirectionLeftTop,BOOL bFirstArrow);

	BOOL LoadCursors();
	void SetLastSize();

	UINT nTimerID;

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNSSplitter)
	//}}AFX_VIRTUAL

protected:
	// Generated message map functions
	//{{AFX_MSG(CNSSplitter)
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	BOOL IsMouseOnBitmap(CPoint pt);
	BOOL IsMouseOnBitmap();
	virtual void SetSplitCursor(int ht);

protected:

	// bitmaps to set on splitter : hover bitmap and regular one
	BOOL SetBitmap(CBitmap &bmp,UINT nRes);
	CBitmap m_objBmp,m_objHover;
	CSize m_szImage; // I assume that every images have the same side
	CRect m_rcLastImageRect;
	BOOL m_bHoverBitmapDrawn;
	
	HCURSOR hCursorHand,hCursorArrow;
	BOOL m_bUseHandCursor;

	int m_nOptimizedSplitterSize;
	BOOL m_bFlatSplitter;
	int m_nSplitterWidth;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NSSPLITTER_H__48442C17_FC1F_11D4_B808_E15C90503603__INCLUDED_)
